// Hit Or Zap
// by MissEshock2002

// This script, from https://ss.deviatenow.com, is protected by this licence :
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/

setInfos(9, "Hit Or Zap", "Hit the button at the right time or get punished! (requires 'Shock Yourself')",
        "MissEshock2002",
        "v1.4", 0x222222, "en", ["eStim", "pain", "game", "forfemale", "formale", "electro"]);

/*
 * TODO stats: time off, shock times, pain levels
 * TODO final punishment
 * TODO speed bonus game: hit x quick rounds in a row. punishment = time sum
 * TODO bonus game: hit time before and close to x seconds
 *  if hit before x seconds: punishment = time - x seconds
 *  if not hit before x: punishment = x seconds
 * TODO option: play shock during guess
 */

String SCRIPTNAME = "HitOrZap"

String DIR = SCRIPTNAME + "/"

// defaults estim
String SOUNDSDIR = "ShockYourself/"
String EXT = ".wav"

List<Integer> PAINLEVELLIMIT = [1, 20]
List<Float> SHOCKTIMELIMIT = [1, 10]


String name = loadString("intro.name")

// Time Hit Game vars
float TIMETOLERANCE = 1.5
float MINTIMETOLERANCE = 0.5
float SHOCKTIMEMULTI = 1.0
float MAXSHOCKTIMEMULTI = 3.0
int MINROUNDS = 5
int MINTIMETOHIT = 7
int MAXTIMETOHIT = 42
int MINTIMETOPREPARE = 10
int MAXTIMETOPREPARE = 15

int BONUS_MINROUNDS = 2
int BONUS_SHOCKTIME_MIN = 10
int BONUS_SHOCKTIME_MAX = BONUS_SHOCKTIME_MIN + 10
int ALL_BONUS_OFFER_MIN_PAINLEVEL = 10  // no bonus under painLevel 10
int BONUS_OFFER_MIN_PAINLEVEL = 18
float BONUS_OFFER_MIN_SHOCKTIMEMULTI = 2.0
float BONUS_OFFER_MIN_TIMETOLERANCE = 1.0
int BOUNSGAMECOUNT = 3
List BONUSGAMES = ["blind_guess", "painLevel_guess", "shockTime_guess"]

int WAITTIME = 30 // +mood in seconds

int COUNTDOWN = 5
boolean TELLTIMETOHIT = true
List<Integer> PAINLEVELRANGE = [6, 16]

// rewards
Map REWARDS = [
        "Pain Level -1"              : -1,
        "Shock Time -0.1 seconds"    : -0.1,
        "Time Tolerance +0.1 seconds": 0.1,
        "Pain Level -2"              : -2,
        "Shock Time -0.2 seconds"    : -0.2,
        "Time Tolerance +0.2 seconds": 0.2,
]

// extra punishments
Map PUNISHMENTS = [
        "%s more Round%s"            : 1,
        "Pain Level +%s"             : 1,
        "Shock Time +%.1f seconds"   : 0.1,
        "Time Tolerance %.1f seconds": -0.1,
]


int minTimeToHit
int maxTimeToHit
int minTimeToPrepare
int maxTimeToPrepare

int round = 1
int rounds
int timeToHit
float timeTolerance
float deltaTime
int painLevel = 1
float shockTime
float timeCount
float shockTimeMulti
float countShockTime = 0
int maxRoundsSuggestion
int countDown
boolean tellTimeToHit
int timer
int inputFails = 0

// mistress' mood in %. 100% = good. 0% = mad!
int mistressMood = loadInteger(SCRIPTNAME + ".mistressMood")
if (mistressMood == null) mistressMood = 100

boolean DISTRACTION = false
boolean distraction = DISTRACTION

int CLOTHESPINSMAXTIME = 600 // seconds
int clothespinsMaxTime = CLOTHESPINSMAXTIME
boolean stripWaitPunishment = false
int clothespinsTime

// game stats
Map<Integer, List> stats = [:] // TODO

String txt = ""


// vars estim
List<String> ESTIMFILENAMES = [
        "burst_sawtooth_100hz_10sec_level",
        "burst_square_100hz_10sec_level",
        "sawtooth_100hz_10sec_level",
        "square_100hz_10sec_level"
]
List<String> estimFileNames = []


def HOSTIMAGES = [
        [DIR + "domme-Alexis2-public.jpg"],
        [DIR + "domme-Alexis3-public.jpg"],
        [DIR + "domme-Alexis4-public.jpg"]
]

def hostImages = HOSTIMAGES[getRandom(HOSTIMAGES.size())]

def waitWithGauge = { float wTime -> if (wTime > 0) waitWithGauge(wTime) }

def getRandomRange = { int min, int max ->
    return min + getRandom(max - min + 1)
}

def getTimeToPrepare = {
    return getRandomRange(minTimeToPrepare, maxTimeToPrepare)
}

def showCountDown = {
    if (countDown == 0) return
    int rndCountDown = countDown - getRandom((int) Math.round(countDown / 2))
    for (int c = rndCountDown; c > 0; c--) {
        show(c)
        wait(1)
    }
}

def showHost = {
    int rndNum = getRandom(hostImages.size())
    def imgPath = hostImages[rndNum]
    setImage(imgPath)
}

def updateMistressMood = { mood ->
    mistressMood += (int) Math.round(mood)
    mistressMood = Math.max(0, Math.min(100, mistressMood))
    save(SCRIPTNAME + ".mistressMood", mistressMood)
}

def getMistressMoodMulti = {
    return 1 + (1 - mistressMood / 100)
}

def getWaitTime = {
    return WAITTIME + painLevel + mistressMood / 2
}

def waitPunishment = {
    updateMistressMood(-5)

    // wait punishments
    String punTxt = "I warned you to not let me wait!\n\nAs a punishment I will "
    List<String> waitPunishments = []
    if (round < maxRoundsSuggestion) waitPunishments.add("One more Round")
    if (painLevel <= 19) waitPunishments.add("Pain Level +1")
    if (shockTimeMulti < MAXSHOCKTIMEMULTI) waitPunishments.add("Shock Time +0.1 seconds")
    if (timeTolerance > MINTIMETOLERANCE) waitPunishments.add("Time Tolerance -0.1 seconds")

    if (!waitPunishments.isEmpty()) {
        String waitPun = waitPunishments[getRandom(waitPunishments.size())]
        switch (waitPun) {
            case "One more Round":
                punTxt += "add one more round!"
                rounds++
                break
            case "Pain Level +1":
                punTxt += "increase the pain level by one!"
                painLevel++
                break
            case "Shock Time +0.1 seconds":
                punTxt += "increase the shock time by 0.1 seconds!"
                shockTimeMulti += 0.1
                break
            case "Time Tolerance -0.1 seconds":
                punTxt += "decrease the time tolerance by 0.1 seconds!"
                timeTolerance -= 0.1
                break
        }
        show(punTxt)
        wait(7)
    }
}

def checkClothespinsTimer = {
    if (clothespinsTime <= 0) return
    int time = getTime()
    if (time > (clothespinsTime + clothespinsMaxTime)) {
        show(String.format("Take off the nipple clamps now, %s!", name))
        showButton("Thank you, Alexis.")
    }
    clothespinsTime = 0
}


// --------------------------------
// eStim functions
// --------------------------------
def getEstimFileNames = {
    List<String> fileNames = []
    List<String> uniqueNames = []
    File dir = new File("sounds/" + SOUNDSDIR)
    try {
        dir.traverse(type: groovy.io.FileType.FILES, maxDepth: 0) { file ->
            if (file.name.endsWith(EXT)) fileNames.add(file.name)
            String fname = file.name.split('\\.')[0]

            List find = fname.findAll('\\d+$')
            if (!find.isEmpty()) {
                if (find[0].isNumber()) {
                    String uName = fname.replaceAll('\\d+$', '')
                    if (!(uName in uniqueNames)) uniqueNames.add(uName)
                }
            }
        }
        List<String> missingNames = []
        uniqueNames.each { uName ->
            for (int lvl = PAINLEVELLIMIT.min(); lvl <= PAINLEVELLIMIT.max(); lvl++) {
                String fname = uName + lvl + EXT
                if (!(fname in fileNames)) {
                    if (!(uName in missingNames)) missingNames.add(fname)
                }
            }
        }
        if (!missingNames.isEmpty()) {
            show("ERROR! Missing sound files: " + missingNames)
            showButton("Quit")
            exit()
        }
        Collections.sort(uniqueNames)
        return uniqueNames
    } catch (Exception e) {
        show("ERROR! 'Shock Yourself' not installed?")
        showButton("Quit")
        exit()
    }
}

def getRandomEstimFileName = { return estimFileNames[getRandom(estimFileNames.size())] }

def playShockSequence = { sTime, pLevel ->
    def shockSequence = []
    if (sTime <= 3 * SHOCKTIMELIMIT.min()) {
        shockSequence = [sTime]
    } else {
        while (shockSequence.sum() < sTime) {
            float min = SHOCKTIMELIMIT.min()
            float rndTime = 2 * min - getRandom(((int) (min * 10))) / 10
            shockSequence.add(rndTime)
        }
        while (shockSequence.sum() > sTime) {
            shockSequence.remove(0)
        }
        shockSequence[-1] = shockSequence[-1] + (sTime - shockSequence.sum())
    }

    shockSequence.each { s ->
        String sound = SOUNDSDIR + getRandomEstimFileName() + pLevel + EXT
        playBackgroundSound(sound)
        wait(s)
        playBackgroundSound(null)
    }

    updateMistressMood(pLevel * sTime / PAINLEVELLIMIT.max())
}

def configEstim = {
    String sound = ""
    int estimIndex = 0
    List<String> testEstimFileNames = getEstimFileNames()
    float stime = 1
    int testPainLevel = PAINLEVELLIMIT[1]
    while (true) {
        txt = "<b>WARNING!\nPressing 'TEST' will play an eStim audio file immediately for " + stime + " seconds!</b>\n\n" +
                "Make sure no other audio sources will play!\n" +
                "Setup your your eStim device properly!" +
                "\n\n1. Attach the electrodes to the bodypart you want to play the game." +
                "\n\n2. Turn your eStim device slowly up and test the highest pain level with different waveforms" +
                " till you think you reached your max pain." +
                " Turn up more, if you dare!" +
                "\n\n<span style='font-size: 12px';')>audio files:\n"

        for (int i = 0; i < testEstimFileNames.size(); i++) {
            if (i == estimIndex) txt += "<b>" + testEstimFileNames[i] + ".wav</b>\n"
            else txt += testEstimFileNames[i] + ".wav\n"
        }
        txt += "</span>"

        int menu = getSelectedValue(txt, ["End Test",
                                          "Cycle Waveform",
                                          "+1",
                                          "-1",
                                          "TEST " + testPainLevel,
        ])
        if (menu == 0) break
        if (menu == 1) estimIndex = (estimIndex + 1) % testEstimFileNames.size()
        if (menu == 2) if (testPainLevel < PAINLEVELLIMIT[1]) testPainLevel++
        if (menu == 3) if (testPainLevel > PAINLEVELLIMIT[0]) testPainLevel--
        if (menu == 4) {
            sound = SOUNDSDIR + testEstimFileNames[estimIndex] + testPainLevel + EXT
            playBackgroundSound(sound)
            if (stime != showButton("STOP!", stime)) playBackgroundSound(null)
            playBackgroundSound(null)
        }
    }
}
// --------------------------------
// eStim functions END
// --------------------------------


// --------------------------------
// config functions
// --------------------------------
def resetDefault = {
    minTimeToHit = MINTIMETOHIT
    maxTimeToHit = MAXTIMETOHIT
    timeTolerance = TIMETOLERANCE
    minTimeToPrepare = MINTIMETOPREPARE
    maxTimeToPrepare = MAXTIMETOPREPARE
    estimFileNames = ESTIMFILENAMES
    countDown = COUNTDOWN
    tellTimeToHit = TELLTIMETOHIT
    distraction = DISTRACTION
}

def loadConfig = {
    minTimeToHit = loadInteger(SCRIPTNAME + ".minTimeToHit")
    maxTimeToHit = loadInteger(SCRIPTNAME + ".maxTimeToHit")
    if (minTimeToHit == null) minTimeToHit = MINTIMETOHIT
    if (maxTimeToHit == null) maxTimeToHit = MAXTIMETOHIT

    timeTolerance = loadFloat(SCRIPTNAME + ".timeTolerance")
    if (timeTolerance == null) timeTolerance = TIMETOLERANCE

    minTimeToPrepare = loadInteger(SCRIPTNAME + ".minTimeToPrepare")
    maxTimeToPrepare = loadInteger(SCRIPTNAME + ".maxTimeToPrepare")
    if (minTimeToPrepare == null) minTimeToPrepare = MINTIMETOPREPARE
    if (maxTimeToPrepare == null) maxTimeToPrepare = MAXTIMETOPREPARE

    countDown = loadInteger(SCRIPTNAME + ".countDown")
    if (countDown == null) countDown = COUNTDOWN

    tellTimeToHit = loadBoolean(SCRIPTNAME + ".tellTimeToHit")
    if (tellTimeToHit == null) tellTimeToHit = TELLTIMETOHIT

    distraction = loadBoolean(SCRIPTNAME + ".distraction")
    if (distraction == null) distraction = DISTRACTION

    List<String> estimNames = getEstimFileNames()
    if (estimNames.isEmpty()) {
        show("Error! Sound file missing?")
        showButton("Quit")
    }
    estimNames.eachWithIndex { String fileName, int i ->
        String estimName = loadString(SCRIPTNAME + ".estimFileNames." + i)
        if (estimName in estimNames) estimFileNames.add(estimName)
    }
    if (estimFileNames.isEmpty()) estimFileNames = estimNames
}

def saveConfig = {
    save(SCRIPTNAME + ".minTimeToHit", minTimeToHit)
    save(SCRIPTNAME + ".maxTimeToHit", maxTimeToHit)
    save(SCRIPTNAME + ".timeTolerance", timeTolerance)
    save(SCRIPTNAME + ".minTimeToPrepare", minTimeToPrepare)
    save(SCRIPTNAME + ".maxTimeToPrepare", maxTimeToPrepare)
    save(SCRIPTNAME + ".estimFileNames", estimFileNames)
    save(SCRIPTNAME + ".countDown", countDown)
    save(SCRIPTNAME + ".tellTimeToHit", tellTimeToHit)
    save(SCRIPTNAME + ".distraction", distraction)
}

def changeConfig = {

    def getParameterText = {
        return "<p style='font-family:monospace;font-size:12px;'>" +
                "Time to Hit ............ " + minTimeToHit + " to " + maxTimeToHit + " seconds\n" +
                "Time Tolerance ......... " + timeTolerance + " seconds\n" +
                "Time to Prepare ........ " + minTimeToPrepare + " to " + maxTimeToPrepare + " seconds\n" +
                "Count Down ............. " + countDown + " seconds\n" +
                "Get Time to Hit told ... " + ((tellTimeToHit) ? "Yes" : "No") + "\n" +
                "Distraction ............ " + ((distraction) ? "Yes" : "No") + "\n" +
                "</p>"
    }

    def changeTimeToHit = {
        while (true) {
            String rangeText = minTimeToHit + "-" + maxTimeToHit
            txt = "The time to guess will be between this times." +
                    " (" + minTimeToHit + " to " + maxTimeToHit + ")" +
                    "\n\nThe minimum is " + MINTIMETOHIT + " seconds." +
                    "\n\nDon't go to high with the maximum!" +
                    " This can be the longest shock you get! Multiplied up to " + MAXSHOCKTIMEMULTI + "!"
            String strRange = getString(txt, rangeText)
            if (strRange.indexOf('-') >= 0) {
                List range = strRange.split('-').collect()
                if (range.every { r -> return r.isInteger() }) {
                    int min = range[0].toInteger()
                    int max = range[1].toInteger()
                    if (min >= MINTIMETOHIT && min <= max) {
                        minTimeToHit = min
                        maxTimeToHit = max
                        break
                    }
                }
            }
        }
    }

    def changeTimeTolerance = {
        while (true) {
            txt = "The time tolerance of what counts as hit." +
                    "\n\nThe minimum is " + MINTIMETOLERANCE + " seconds." +
                    "(Will be rounded to one decimal behind point.)"
            timeTolerance = getFloat(txt, timeTolerance)
            if (timeTolerance >= MINTIMETOLERANCE && timeTolerance < minTimeToHit) {
                timeTolerance = ((int) Math.round(10 * timeTolerance)) / 10
                break
            }
        }
    }

    def changeTimeToPrepare = {
        while (true) {
            String rangeText = minTimeToPrepare + "-" + maxTimeToPrepare
            txt = "How many seconds to prepare befor shock sequence starts." +
                    " (" + minTimeToPrepare + " to " + maxTimeToPrepare + ")"
            String strRange = getString(txt, rangeText)
            if (strRange.indexOf('-') >= 0) {
                List range = strRange.split('-').collect()
                if (range.every { r -> return r.isInteger() }) {
                    int min = range[0].toInteger()
                    int max = range[1].toInteger()
                    if (min <= max) {
                        minTimeToPrepare = min
                        maxTimeToPrepare = max
                        break
                    }
                }
            }
        }
    }

    def changeCountDown = {
        while (true) {
            txt = "How many seconds the count down will be at before you have to hit the time." +
                    " The count down is some times shorter, but never longer."
            countDown = getInteger(txt, countDown)
            if (countDown >= 0) break
        }
    }

    def changeTellTimeToHit = {
        while (true) {
            txt = "Will Alexis tell you the time you have to hit befor you try?"
            tellTimeToHit = getBoolean(txt)
            break
        }
    }

    def changeDistraction = {
        while (true) {
            txt = "Will Alexis try to distract you with random numbers?"
            distraction = getBoolean(txt)
            break
        }
    }

    def changeEstimFileNames = {
        while (true) {
            List estimNames = getEstimFileNames()
            List checkBox = [false] * estimNames.size()
            int i = 0
            estimNames.each { e ->
                if (e in estimFileNames) checkBox[i] = true
                i++
            }
            checkBox = getBooleans("eStim sound files:", estimNames, checkBox)
            if (!checkBox) break
            estimFileNames.clear()
            i = 0
            estimNames.each { e ->
                if (checkBox[i]) estimFileNames.add(e)
                i++
            }
            if (!estimFileNames.isEmpty()) break
        }
    }

    boolean bConf = true
    while (bConf) {
        txt = "" +
                getParameterText()
        int menu = getSelectedValue(txt, [
                "Time to Hit",
                "Time Tolerance",
                "Time to Prepare",
                "Count Down",
                "Get Time to Hit told",
                "Distraction",
                "eStim sound files",
                "----------------",
                "Reset to default",
                "Save & Exit",
                "Exit",
        ])
        switch (menu) {
            case 0:
                changeTimeToHit()
                break
            case 1:
                changeTimeTolerance()
                break
            case 2:
                changeTimeToPrepare()
                break
            case 3:
                changeCountDown()
                break
            case 4:
                changeTellTimeToHit()
                break
            case 5:
                changeDistraction()
                break
            case 6:
                changeEstimFileNames()
                break
        //  case ? ----------------
            case 8:
                if (getBoolean("Reset to default?")) resetDefault()
                break
            case 9: // Save & Exit
                saveConfig()
                bConf = false
                break
            case 10: // Exit
                bConf = false
                break
        }
    }
}
// --------------------------------
// config functions END
// --------------------------------


def updateStats = {
    List newStat = [deltaTime, painLevel, shockTime]
    stats[round] = newStat
}


// --------------------------------
// Bonus Rounds
// --------------------------------
def playBonusPunishment = { sTime ->
    if (sTime == 0) return
    if (sTime <= MINTIMETOLERANCE) {
        txt = "Very close! I will not shock you for a few milliseconds."
        show(txt)
        wait(3)
    } else {
        txt = String.format("Get ready for <b>%.1f seconds of shocks</b>!", sTime)
        show(txt)
        waitWithGauge(getTimeToPrepare())
        playShockSequence(sTime, painLevel)
    }
}

def showRewardCountDown = {
    if (getTimeToPrepare() > 0) {
        txt = "Enjoy your reward!"
        show(txt)
        if (getTimeToPrepare() > 3) waitWithGauge(getTimeToPrepare())
        else wait(3)
    }
}

def playBonusPainLevelReward = {
    showRewardCountDown()
    txt = "Pain level %s"
    int newPainLevel = Math.min((painLevel - (BONUS_SHOCKTIME_MIN - Math.round(deltaTime))), PAINLEVELLIMIT.max())
    for (int plvl = painLevel; plvl >= newPainLevel; plvl--) {
        float sTime = (float) (painLevel / plvl) * getMistressMoodMulti()
        show(String.format(txt, plvl))
        String sound = SOUNDSDIR + getRandomEstimFileName() + plvl + EXT
        playBackgroundSound(sound)
        wait(sTime)
        playBackgroundSound(null)
    }
    wait(2)
    painLevel = newPainLevel
}

def playBonusShockTimeMultiReward = {
    showRewardCountDown()
    txt = "Shock time %.1f seconds"
    float newShockTimeMulti = shockTimeMulti - (Math.ceil(10 - deltaTime) / 10)
    int timeIdx = 1 + (int) (10 * Math.abs(newShockTimeMulti - shockTimeMulti))
    for (int i = 1; i <= timeIdx; i++) {
        float sTime = shockTimeMulti - i / 10
        show(String.format(txt, sTime))
        String sound = SOUNDSDIR + getRandomEstimFileName() + painLevel + EXT
        playBackgroundSound(sound)
        wait(sTime)
        playBackgroundSound(null)
        wait(sTime / 2)
    }
    wait(2)
    shockTimeMulti = newShockTimeMulti
}

def playBonusTimeToleranceReward = {
    showRewardCountDown()
    txt = "Time tolerance %.1f seconds"
    float newTimeTolerance = timeTolerance + (Math.ceil(10 - deltaTime) / 10)
    int timeIdx = (int) (10 * Math.abs(newTimeTolerance - timeTolerance))
    for (int i = 1; i <= timeIdx; i++) {
        float sTime = timeTolerance + i / 10
        show(String.format(txt, sTime))
        String sound = SOUNDSDIR + getRandomEstimFileName() + painLevel + EXT
        playBackgroundSound(sound)
        wait(sTime)
        playBackgroundSound(null)
        wait(sTime / 2)
    }
    wait(2)
    timeTolerance = newTimeTolerance
}

def playBonusGameBlindGuess = {
    show(String.format("Ready, %s?", name))
    showButton("Ready!")

    showCountDown()
    txt = "Hit 'Stop!' when you think the time has passed!"
    show(txt)

    timeCount = showButton("Stop!", (BONUS_SHOCKTIME_MIN + BONUS_SHOCKTIME_MAX))
    timeToHit = BONUS_SHOCKTIME_MIN + getRandom(BONUS_SHOCKTIME_MIN + 1)
    deltaTime = Math.abs(timeCount - timeToHit)

    if (timeCount < (BONUS_SHOCKTIME_MIN + BONUS_SHOCKTIME_MAX)) {
        txt = "You hit 'Stop' after " + timeCount + " seconds."
    } else {
        txt = "<b>Time Up!</b> You din't hit 'Stop' after " + (BONUS_SHOCKTIME_MIN + BONUS_SHOCKTIME_MAX) + " seconds!"
    }
    txt += "\n\nThe time you had to hit was... "
    show(txt)
    wait(2)
    txt += timeToHit + " seconds."
    show(txt)
    wait(3)

    return deltaTime
}

def playBonusGamePainLevelGuess = {
    show("<b>Get ready for the shocks!</b>")

    float sTime = BONUS_SHOCKTIME_MIN / 2 * getMistressMoodMulti()
    int minP = Math.max(10, painLevel - 10)
    int plvlToGuess = minP + getRandom(painLevel - minP + 1)
    plvlToGuess = Math.max(PAINLEVELLIMIT.min(), Math.min(PAINLEVELLIMIT.max(), plvlToGuess))
    waitWithGauge(getTimeToPrepare())
    playShockSequence(sTime, plvlToGuess)

    txt = "Now tell me what pain level was it!"
    int plvlGuess = 0
    while (plvlGuess == 0) {
        String plvlGuessStr = getString(txt, "")
        if (plvlGuessStr.isInteger()) {
            plvlGuess = plvlGuessStr.toInteger()
        }
    }

    int deltaPlvl = Math.abs(plvlToGuess - plvlGuess)

    if (plvlGuess == plvlToGuess) {
        show("Your guess is right!")
        wait(3)
        return deltaPlvl
    } else {
        show("Your guess is wrong! The pain level was " + plvlToGuess + ".")
        wait(3)
        return deltaPlvl
    }
}

def playBonusGameShockTimeGuess = {
    float sTime = 0
    sTime = Math.round(BONUS_SHOCKTIME_MIN * getMistressMoodMulti())
    sTime = sTime / 2 + getRandom((int) (sTime + 1))
    sTime = Math.max((BONUS_SHOCKTIME_MIN / 2), Math.min(maxTimeToHit, sTime))

    show("<b>Get ready for the shocks!</b>")
    waitWithGauge(getTimeToPrepare())
    playShockSequence(sTime, painLevel)

    txt = "Now tell me how long the shock was!"
    int timeGuess = 0
    while (timeGuess == 0) {
        String timeGuessStr = getString(txt, "")
        if (timeGuessStr.isInteger()) {
            timeGuess = timeGuessStr.toInteger()
        }
    }
    deltaTime = Math.abs(sTime - timeGuess)
    if (timeGuess == sTime) {
        show("Your guess is right!")
        wait(3)
        return deltaTime
    } else {
        show(String.format("Your guess is wrong! The shock was %.0f seconds long.", sTime))
        wait(3)
        return deltaTime
    }
}

def playBonusGame = {
    if (round < BONUS_MINROUNDS) return
    if (painLevel < ALL_BONUS_OFFER_MIN_PAINLEVEL) return

    boolean bonusOffered = false
    List<String> bonusOffers = []

    if (painLevel >= BONUS_OFFER_MIN_PAINLEVEL) {
        bonusOffers.add("painLevel_bonus")
    }
    if (shockTimeMulti >= BONUS_OFFER_MIN_SHOCKTIMEMULTI) {
        bonusOffers.add("shockTimeMulti_bonus")
    }
    if (timeTolerance <= BONUS_OFFER_MIN_TIMETOLERANCE) {
        bonusOffers.add("timeTolerance_bonus")
    }

    if (!bonusOffers.isEmpty()) {
        List bonusGames = BONUSGAMES
        if (painLevel < PAINLEVELRANGE.min()) {
            bonusOffers = bonusOffers - ["painLevel_bonus"]
        }
        String bonusGame = bonusGames[getRandom(BONUSGAMES.size())]

        Collections.shuffle(bonusOffers)
        String bonusType = bonusOffers[0]
        if (bonusType == "painLevel_bonus") {
            txt = "You are at a high pain level and you have some rounds to play." +
                    "\n\nI offer you the chance to lower the pain level up to 10 levels!"
        } else if (bonusType == "shockTimeMulti_bonus") {
            txt = "You are at high shock time and you have some rounds to play." +
                    "\n\nI offer you the chance to lower the shock time by up to 1 second!"
        } else if (bonusType == "timeTolerance_bonus") {
            txt = "You are at a low time tolerance and you have some rounds to play." +
                    "\n\nI offer you the chance to increase the time tolerance by up to 1 second!"
        }

        if (bonusGame == "blind_guess") {
            txt += "\n\nYou have to hit a random time between " + BONUS_SHOCKTIME_MIN + " and " +
                    "" + BONUS_SHOCKTIME_MAX + " seconds, but I will not tell you what time that is!" +
                    "\nThe closer you are, the higher your reward." +
                    "\nEvery second off will be punished with pain level " + painLevel + " shocks!"
        } else if (bonusGame == "painLevel_guess") {
            txt += "\n\nI will shock you for a few seconds at a random pain level." +
                    "\nAfter that you tell me what pain level it was." +
                    "\nYour guess must be precise!" +
                    "\nEvery level off will be punished for 1 second at pain level " + painLevel + "!"
        } else if (bonusGame == "shockTime_guess") {
            txt += "\n\nI will shock you for a few seconds at pain level " + painLevel + "." +
                    "\nAfter that you tell me how long the shock was." +
                    "\nYour guess must be precise!"
        }

        if (bonusType == "painLevel_bonus") {
            txt += "\n\nIf you don't fail completly, I will turn the pain level <i>slowly</i> down while I shock you!"
        } else if (bonusType == "shockTimeMulti_bonus") {
            txt += "\n\nIf you don't fail completly, I will decrease the shock time <i>very slowly</i> while I shock you!"
        } else if (bonusType == "timeTolerance_bonus") {
            txt += "\n\nIf you don't fail completly, I will increase the time tolerance <i>slowly</i> while I shock you!"
        }

        txt += "\n\nDo you want my offer?"

        if (getBoolean(txt, "Yes. Thank you, Alexis.", "No. Thank you, Alexis.")) {
            if (bonusGame == "blind_guess") deltaTime = playBonusGameBlindGuess()
            if (bonusGame == "painLevel_guess") deltaTime = playBonusGamePainLevelGuess()
            if (bonusGame == "shockTime_guess") deltaTime = playBonusGameShockTimeGuess()

            // punishment
            playBonusPunishment(deltaTime)

            updateMistressMood(painLevel / 5)

            // reward
            if (deltaTime <= (BONUS_SHOCKTIME_MIN - 1)) {
                if (bonusType == "painLevel_bonus") {
                    // turn pain levels down
                    if (deltaTime <= (BONUS_SHOCKTIME_MIN + BONUS_SHOCKTIME_MAX)) {
                        playBonusPainLevelReward()
                    }
                } else if (bonusType == "shockTimeMulti_bonus") {
                    // turn shock time down
                    if (deltaTime < BONUS_SHOCKTIME_MIN) {
                        playBonusShockTimeMultiReward()
                    }
                } else if (bonusType == "timeTolerance_bonus") {
                    // turn time tolerance up
                    if (deltaTime < BONUS_SHOCKTIME_MIN) {
                        playBonusTimeToleranceReward()
                    }
                }
            } else {
                show("You erned no reward.")
                wait(4)
            }
        } else {
            show("Refusing my generous offer is not a good idea!")
            wait(4)
            updateMistressMood(-painLevel / 5)
        }
    }
}
// --------------------------------
// Bonus Rounds END
// --------------------------------


// --------------------------------
// Rewards & Extra Punishments
// --------------------------------
def offerRewards = {
    // bad mood = chance for no rewards
    if (mistressMood > getRandom(25)) {
        updateMistressMood(+5)
        wait(1)
        return
    }

    txt = "You have %s rounds to play." +
            "\n\nThe current pain level is %s." +
            "\n\nEvery second off is punished with %.1f seconds of shock." +
            "\n\nThe time tolerance is %.1f seconds."
    txt = String.format(txt,
            (rounds - round - 1),
            painLevel,
            shockTimeMulti,
            timeTolerance)

    List<String> rewards = []
    if (deltaTime > 0.1) {
        // normal rewards
        txt += "\n\n<b>Choose your reward:</b>"
        if (painLevel >= 2) rewards.add("Pain Level -1")
        if (shockTimeMulti > 1) rewards.add("Shock Time -0.1 seconds")
        if (timeTolerance < 2) rewards.add("Time Tolerance +0.1 seconds")
    } else {
        // lucky rewards
        txt += "\n\n<b>Choose your lucky reward:</b>"
        if (painLevel >= 3) rewards.add("Pain Level -2")
        if (shockTimeMulti > 1) rewards.add("Shock Time -0.2 seconds")
        if (timeTolerance < 2) rewards.add("Time Tolerance +0.2 seconds")
    }
    if (!rewards.isEmpty() && round < rounds) {
        int menuRewards = getSelectedValue(txt, rewards)
        if (rewards[menuRewards].contains("Pain Level")) painLevel += REWARDS[rewards[menuRewards]]
        if (rewards[menuRewards].contains("Shock Time")) shockTimeMulti += REWARDS[rewards[menuRewards]]
        if (rewards[menuRewards].contains("Time Tolerance")) timeTolerance += REWARDS[rewards[menuRewards]]
    } else {
        wait(1)
    }
}

def offerExtraPunishments = {
    int extraPunMulti = 1
    if (mistressMood < 25) extraPunMulti = 3
    else if (mistressMood < 50) extraPunMulti = 2

    Map extraPunishments = [:]

    if (round < (maxRoundsSuggestion * getMistressMoodMulti())) {
        int moreRounds = extraPunMulti * PUNISHMENTS["%s more Round%s"]
        String btnText = String.format("%s more Round%s", moreRounds, ((moreRounds > 1) ? "s" : ""))
        extraPunishments[btnText] = moreRounds
    }

    int addPainLevel = Math.min(extraPunMulti, (PAINLEVELLIMIT.max() - painLevel))
    if (addPainLevel > 0) {
        String btnText = String.format("Pain Level +%s", addPainLevel)
        extraPunishments[btnText] = addPainLevel
    }

    float addShockTimeMulti = Math.min((extraPunMulti / 10), (MAXSHOCKTIMEMULTI - shockTimeMulti))
    if (shockTimeMulti < MAXSHOCKTIMEMULTI) {
        String btnText = String.format("Shock Time +%.1f seconds", addShockTimeMulti)
        extraPunishments[btnText] = addShockTimeMulti
    }

    float minusTimeTolerance = -Math.min((extraPunMulti / 10), (MINTIMETOLERANCE + timeTolerance))
    if (timeTolerance > MINTIMETOLERANCE) {
        String btnText = String.format("Time Tolerance %.1f seconds", minusTimeTolerance)
        extraPunishments[btnText] = minusTimeTolerance
    }

    int menuExtraPun = getRandom(extraPunishments.size())

    // bad mood = chance for Mistress choose extra punishment
    boolean mistressChoose = (mistressMood < getRandom(50))

    if (!mistressChoose) {
        if (!extraPunishments.isEmpty() && round < rounds) {
            txt = "You have %s rounds to play." +
                    "\n\nThe current pain level is %s." +
                    "\n\nEvery second off is punished with %.1f seconds of shock." +
                    "\n\nThe time tolerance is %.1f seconds." +
                    "\n\n<b>Choose your extra punishment:</b>"
            txt = String.format(txt,
                    (rounds - round),
                    painLevel,
                    shockTimeMulti,
                    timeTolerance)
            menuExtraPun = getSelectedValue(txt, extraPunishments.keySet().toList())
        }
    }

    switch (menuExtraPun) {
        case 0:
            rounds += extraPunishments[extraPunishments.keySet()[menuExtraPun]]
            break
        case 1:
            painLevel += extraPunishments[extraPunishments.keySet()[menuExtraPun]]
            break
        case 2:
            shockTimeMulti += extraPunishments[extraPunishments.keySet()[menuExtraPun]]
            break
        case 3:
            timeTolerance += extraPunishments[extraPunishments.keySet()[menuExtraPun]]
            break
    }

    if (mistressChoose) {
        show("This time I choose your extra punishment!")
        wait(3)
        show("Your extra punishment is: " + extraPunishments.keySet()[menuExtraPun])
        wait(2)
    }
    wait(1)
}
// --------------------------------
// Rewards & Extra Punishments END
// --------------------------------


def inputPainLevel = {
    timer = getTime()
    while (true) {
        int moodPainLevel = Math.round((getMistressMoodMulti() - 1) * PAINLEVELRANGE.max())
        int minPainLevel = Math.max(PAINLEVELRANGE.min(), Math.min(PAINLEVELRANGE.max(), moodPainLevel))
        painLevel = minPainLevel

        if (minPainLevel <= (PAINLEVELLIMIT.max() - PAINLEVELRANGE.min())) {
            txt = "With what pain level do you want to start, " + name + "?" +
                    "\n\nI think the minimum pain level has to be " + minPainLevel + "!" +
                    "\n\nThe pain level is increased every round by one and goes up to " + PAINLEVELLIMIT.max() + "!" +
                    "\n\nThe higher you go, the less rounds you have to play."
            painLevel = getInteger(txt, minPainLevel)
            if (painLevel >= minPainLevel && painLevel <= PAINLEVELLIMIT.max()) {
                updateMistressMood(painLevel - minPainLevel) // increase mood a little
                break
            } else {
                updateMistressMood(-5)
                if (painLevel > PAINLEVELLIMIT.max()) {
                    txt = "You can't go over " + PAINLEVELLIMIT.max() + "!"
                    show(txt)
                    wait(3)
                } else {
                    if (minPainLevel < (PAINLEVELRANGE.max() - 1)) {
                        txt = "I told you the minimum is " + minPainLevel + "! Let's try this again."
                        show(txt)
                        wait(3)
                    }
                }
            }
        } else {
            txt = "I set the pain level you have to start with to " + minPainLevel + "!" +
                    "\n\nYou have no say in this."
            show(txt)
            wait(4)
            break
        }
    }

    if ((getTime() - timer) > getWaitTime()) {
        updateMistressMood(-5)
        if (mistressMood <= 50) stripWaitPunishment = true
        txt = "Why does it take you so long to tell me a simple number?"
        if (painLevel < PAINLEVELRANGE.max()) {
            painLevel++
            txt += "\n\nAs a punishment you will start with pain level " + painLevel + "!"
        }
        show(txt)
        wait(5)
    }
}

def inputRounds = {
    timer = getTime()
    while (true) {
        maxRoundsSuggestion = 10 * Math.round(((PAINLEVELLIMIT.max() + 1 - painLevel) +
                10 * (timeTolerance - MINTIMETOLERANCE) +
                10 * (MAXSHOCKTIMEMULTI - shockTimeMulti)) / 10)
        int moodRounds = (int) Math.round((getMistressMoodMulti() - 1) * maxRoundsSuggestion)
        moodRounds = (int) (Math.round(moodRounds / 10) * 5)
        int minRounds = Math.max((PAINLEVELLIMIT.max() - painLevel), moodRounds)
        minRounds = Math.max(minRounds, MINROUNDS)
        rounds = minRounds

        txt = "How many rounds do you want to play, " + name + "?"
        if (mistressMood == 100) {
            txt += "\n\nYou choose a pain level of " + painLevel + "." +
                    " This means you have to play at least " + minRounds + " rounds."
        } else {
            txt += "\n\nYou have to play at least " + minRounds + " rounds."
        }
        if (minRounds < maxRoundsSuggestion) txt += "\n\nI suggest to not go over " + maxRoundsSuggestion + "."
        else txt += "\n\nI suggest to not go higher."

        rounds = getInteger(txt, minRounds)
        if (rounds >= minRounds) {
            if (rounds > maxRoundsSuggestion) {
                updateMistressMood(rounds - maxRoundsSuggestion) // increase mood a little
                show("Brave but foolish!")
                wait(3)
            }
            break
        } else {
            updateMistressMood(-5)
            if (rounds < minRounds) txt = "I told you the minimum is " + minRounds + " rounds! Let's try this again."
            show(txt)
            wait(3)
        }
    }

    if ((getTime() - timer) > getWaitTime()) {
        updateMistressMood(-5)
        if (mistressMood <= 50) stripWaitPunishment = true
        txt = "Why does it take you so long to tell me a simple number?"
        if (rounds < maxRoundsSuggestion) {
            int punRounds = 10 * (getMistressMoodMulti() - 1)
            rounds += punRounds
            txt += "\n\nAs a punishment you will have to play " + punRounds + " more rounds!"
        }
        show(txt)
        wait(5)
    }
}

def playTimeHitRound = {

    def showOverview = {
        if (tellTimeToHit) {
            String overviewTxt = "Round %s of %s." +
                    "\n\nThe timespan you have to guess right is <b>%s seconds</b>." +
                    "\n\nYou have a tolerance of %.1f seconds. " +
                    "\nEvery guess between %.1f and %.1f seconds will go unpunished." +
                    "\n\nEvery second off is %.1f seconds of shock in this round." +
                    "\n\nThe current pain level is %s." +
                    "\n\nReady, %s? Don't let me wait!"
            show(String.format(overviewTxt,
                    round,
                    rounds,
                    timeToHit,
                    timeTolerance,
                    (timeToHit - timeTolerance),
                    (timeToHit + timeTolerance),
                    shockTimeMulti,
                    painLevel,
                    name
            ))
        } else {
            String overviewTxt = "Round %s of %s." +
                    "\n\nI will tell you the timespan you have to guess right after you started the round." +
                    "\n\nYou have a tolerance of %.1f seconds. " +
                    "\n\nEvery second off is %.1f seconds of shock in this round." +
                    "\n\nThe current pain level is %s." +
                    "\n\nReady, %s? Don't let me wait!"
            show(String.format(overviewTxt,
                    round,
                    rounds,
                    timeTolerance,
                    shockTimeMulti,
                    painLevel,
                    name
            ))
        }
    }

    while (true) {
        showOverview()
        if (showButton("Ready!", getWaitTime()) >= getWaitTime()) {
            waitPunishment() // wait punishments
        } else break
    }

    showCountDown()

    show("<b>" + timeToHit + " seconds!</b>\n\nHit 'Stop!' when you think " + timeToHit + " seconds have passed!")

    if (!distraction) {
        return showButton("Stop!", 2 * timeToHit)
    } else {
        // distractions
        float timeLeft = 2 * timeToHit
        List disTexts = ["%s... maybe...", "%s seconds...", "Could be %s seconds.", "Lost count after %s seconds?"]
        while (timeLeft > 0) {
            int rndTime = 3 + getRandom(4)
            float time = 0
            if (timeLeft < rndTime) rndTime = rndTime - timeLeft
            time = showButton("Stop!", rndTime)
            timeLeft -= time
            if (time != rndTime) {
                break
            } else {
                int disTime = (int) ((2 * timeToHit - timeLeft) + 2 - getRandom(2))
                if (disTime > rndTime) {
                    txt = String.format(disTexts[getRandom(disTexts.size())], disTime)
                    show(txt)
                }
            }
        }
        return (2 * timeToHit - timeLeft)
    }
}

def playTimeHitGameRounds = {
    for (round = 1; round <= rounds; round++) {

        playBonusGame() // offer bonus round

        timeCount = playTimeHitRound()
        deltaTime = Math.abs(timeCount - timeToHit)
        if (deltaTime <= timeTolerance) {
            txt = "Time Hit!\n\nYou are " + deltaTime + " seconds off. "
            if (deltaTime <= 0.1) txt += "Lucky!"
            else if (deltaTime > 0.9 * timeTolerance) txt += "That was close!"
            else if (deltaTime > 0.95 * timeTolerance) txt += "You almost got punished!"
            show(txt)

            offerRewards() // rewards

        } else {
            txt = "<b>Missed!</b>\n\nYou are " + deltaTime + " seconds off."
            if (timeCount >= (2 * timeToHit)) {
                txt = "<b>Time Up!</b>"
            }

            // punishment
            shockTime = shockTimeMulti * deltaTime
            txt += "\n\nGet ready for <b>" + shockTime + " seconds of shocks</b>!" +
                    "\n\nYou have " + getTimeToPrepare() + " seconds to prepare!"
            show(txt)
            waitWithGauge(getTimeToPrepare())
            playShockSequence(shockTime, painLevel)
            countShockTime += shockTime
        }

//         updateStats() // TODO

        painLevel++
        painLevel = Math.min(painLevel, PAINLEVELLIMIT.max())

        // extra punishments
        if (deltaTime > timeTolerance) {
            offerExtraPunishments()
        }

        if (deltaTime <= timeTolerance) timeToHit += 3 + getRandom(painLevel)
        else timeToHit += 1 + getRandom(painLevel)
        if (timeToHit > maxTimeToHit) timeToHit = maxTimeToHit - getRandom(painLevel)
        timeToHit = Math.min(timeToHit, maxTimeToHit)
        timeToHit = Math.max(timeToHit, minTimeToHit)

        checkClothespinsTimer()
    }
}

def playTimeHitGame = {
    rounds = MINROUNDS
    painLevel = PAINLEVELRANGE.min()
    shockTimeMulti = SHOCKTIMEMULTI
    timeTolerance = TIMETOLERANCE
    timeToHit = minTimeToHit + getRandom(painLevel)
    timeToHit = Math.min(timeToHit, maxTimeToHit)
    timeToHit = Math.max(timeToHit, minTimeToHit)
    timeCount = 0
    shockTime = 0
    stripWaitPunishment = false

    // strip
    show(String.format("Strip for us, %s! Now!", name))
    while (true) {
        if (showButton("I'm naked, Alexis.", getWaitTime()) >= getWaitTime()) {
            updateMistressMood(-5)
            if (mistressMood <= 50) stripWaitPunishment = true
            show("Why does it take you so long to strip?")
            wait(3)
        } else {
            break
        }
    }

    // punishment for waiting: clothespins
    // TODO other toys
    if (stripWaitPunishment && loadBoolean("toys.clothespins")) {
        if (mistressMood <= 25) {
            show(String.format("Get on all fours, crawl and get two clothespins, %s!", name))
        } else {
            show(String.format("Go get two clothespins, %s!", name))
        }
        showButton("I have the clothespins, Alexis.")
        txt = "As punishment for letting me wait you have to put one clothespin on each nipple!"
        show(txt)
        wait(3)
        txt += "\n\nI'll tell you when to take them off."
        show(txt)
        showButton("The clothespins are on my nipples, Alexis.")
        updateMistressMood(+5)
        clothespinsMaxTime = (100 - mistressMood) * 10
        clothespinsMaxTime = Math.min(clothespinsMaxTime, CLOTHESPINSMAXTIME)
        clothespinsTime = getTime()
        stripWaitPunishment = false
    }

    // bondage
    // TODO timer
    show("Now put your ass in the torture chair!\n" +
            "Bind your legs to the chair, if you think you will have struggle to keep in the seat!\n" +
            "Attach electrodes to your most sensitive bits.\n" +
            "You may also bind one hand, if you think you can't controll yourself.")
    showButton("I'm ready, Alexis.")

    // start with painlevel
    inputPainLevel()

    // how man rounds
    inputRounds()

    // punishment for waiting, if no toys
    if (stripWaitPunishment) {
        int pLevel = painLevel
        float sTime = Math.max(0.5, (getMistressMoodMulti() - 1))
        txt = "Before we start, I will punish you for letting me wait!" +
                "\n\nI'll turn up the pain level up to " + pLevel + " while shocking you!" +
                "\n\nTake this as a warmup."
        show(txt)
        showButton("I'm ready, Alexis.")
        show("I'll turn up the pain level up to " + pLevel + " while shocking you!" +
                "\n\n<b>Get ready for the punishment shocks!</b>")
        waitWithGauge(getTimeToPrepare())
        txt = "The pain level is %s."
        float sTimeSum = 0
        for (int plvl = 1; plvl <= pLevel; plvl++) {
            show(String.format(txt, plvl))
            String sound = SOUNDSDIR + getRandomEstimFileName() + painLevel + EXT
            playBackgroundSound(sound)
            wait(sTime)
            playBackgroundSound(null)
            sTimeSum += sTime
        }
        updateMistressMood(pLevel * sTimeSum / PAINLEVELLIMIT.max())
        stripWaitPunishment = false
        wait(3)
    }

    // play Hit or Zap
    playTimeHitGameRounds()

    // TODO outro
    wait(2)
    show("That was a fun! Don't you agree? I hope we see you again soon, " + name + ".")
    showButton("Yes, Alexis.")
}


def showIntro = {

    showHost()

    // TODO "welcome back"
    txt = "Welcome to 'Hit or Zap!', " + (loadString("intro.name")) + "." +
            "\n\nI am Alexis. I am not only the host of 'Hit or Zap!'. I am your torturer, if you mess up!"
    show(txt)

    if (showButton("Hello, Alexis.", getWaitTime()) >= getWaitTime()) {
        // wait 1st time
        show("Don't let me wait!")
        for (int wCount = 1; wCount <= 3; wCount++) {
            if (wCount < 3) {
                updateMistressMood(-5)
                if (showButton("I'm sorry, Alexis.", getWaitTime()) >= getWaitTime()) {
                    // wait 2nd time
                    updateMistressMood(-5)
                    show("Don't let me wait!")
                } else {
                    show("Don't let me wait again!")
                    wait(3)
                    break
                }
            } else if (wCount == 3) {
                updateMistressMood(-10)
                show("If you don't want to play, don't waste my time!")
                wait(3)
                return
            }


        }
    }

    int time = getTime()
    if (!getBoolean("Do you know how 'Hit or Zap!' is played, " + name + "?")) {
        txt = "Here is how the game goes.\n\n" +
                "You will strip for us. You will attach electrodes to your most sensitive bits." +
                " You will take seat in the torture chair." +
                " If you need it, you can bound your legs to the chair. You can bound one arm too." +
                " You need one free hand to press buttons or input numbers!" +
                "\n\nI will tell you a timespan. You start the timer." +
                "\n\nAll you have to do is to guess when that time has past and stop the timer." +
                " The closer you are the shorter the electroshocks will be you'll get." +
                "\n\nSuch a simple task." +
                "\n\nOne more thing: If you hit the time, I might offer you rewards." +
                "\nIf you don't hit the time, I will offer you extra punishments." +
                "\n\nEverything understood?"
        if (getBoolean(txt)) {
            show("Good! Let's get started!")
        } else {
            show("Too bad! You will learn it the hard way!")
        }
        wait(2)
    } else {
        if ((getTime() - time) > getWaitTime()) {
            updateMistressMood(-5)
            show("Why does it take you so long to say yes, if you know the rules?")
            wait(3)
        }
    }

    playTimeHitGame()
}

def showTitleScreen = {
    setImage(SCRIPTNAME + "/HitOrZap_intro.png")
    txt = "<span style='font-size: xx-large';')>Hit or Zap!</span>" +
            "\n\nConfigure eStim before start!"
    int menu = getSelectedValue(txt, [
            "Start",
            "Config eStim",
            "Config",
    ])
    switch (menu) {
        case 0:
            showIntro()
            break
        case 1:
            configEstim()
            break
        case 2:
            changeConfig()
            break
    }
}


loadConfig()

while (true) {
    playBackgroundSound(null)
    show(null)
    showTitleScreen()
}

/*
 * Resources
 * scripts/HitOrZap.groovy
 * images/HitOrZap/*
 */
